#include <time.h>
#include <windows.h>
#include <vector>

typedef int64_t i64;
typedef unsigned int uint;
const uint SS=32768; // SegmentSize
bool *seg=(bool*)malloc(SS),*ptC;

i64 SegmA(i64 N) {
  uint sqrtN=(uint)std::sqrt((double)N);
  i64 s=2,n=3,c=(N<2)?0:1; // c: quantit de premiers 
  ptC=(bool*)malloc(sqrtN+1);
  for(uint i=0; i<=sqrtN; ++i) ptC[i]=true;
  for(uint i=2; i*i<=sqrtN; ++i) // Crible d'Eratosthne classique
    if(ptC[i])
      for(uint q=sqrtN/i; q>=i; --q)
        if(ptC[q]) ptC[i*q]=false;
  std::vector<uint> pos,nxt;
  for(i64 a=0; a<=N; a+=SS) { // Segments
    for (uint i=0; i<SS; ++i) seg[i]=true;
    i64 b=min(a+SS-1,N);
    for(i64 ss=s*s; ss<=b; s++,ss=s*s)
      if(ptC[s]) {pos.push_back((uint)(s+s)); nxt.push_back((uint)(ss-a));}
    for(uint i=1; i<pos.size(); i++) {
      uint j=nxt[i];
      for(uint k=pos[i]; j<SS; j+=k) seg[j]=false;
      nxt[i]=j-SS;
    }
    while (n<=b) {
      if(seg[n-a]) c++; // n est un nombre premier
      n+=2;
    }
  }
  return c;
}
int main() {
  for(i64 N=10; N<=100000000000; N*=10) {
    clock_t t=GetTickCount();
    i64 n=SegmA(N);
    printf("%I64i/%I64i, %d ms\n",n,N,GetTickCount()-t);
    free(ptC);
  }
  getchar();
}